﻿using System;
using System.Collections.Generic;
using Wisej.Web;


namespace UserControlFlowLayout_Example
{
	public partial class Dashboard_Main : Page
    {
        List<Order> _Orders;

        List<string> _Customers;
        List<string> _Carriers;
        List<string> _Addresses;
        List<string> _Freights;
        List<string> _CustomerPrices;
        List<string> _CarrierPrices;
        public Dashboard_Main()
        {
            InitializeComponent();

			this.flowLayoutPanel1.ScrollBars = ScrollBars.Vertical;
			this.flowLayoutPanel1.Scroll += FlowLayoutPanel1_Scroll;
        }

		private void FlowLayoutPanel1_Scroll(object sender, ScrollEventArgs e)
		{
			// Detect scroll to the bottom.
			if (e.Type == ScrollEventType.Last)
			{
				FillFlowLayoutPanel();
			}
			else
			{
				// Detect partial uncovering of the loading placeholder.
				Label lbl_More = (Label)flowLayoutPanel1.Controls["lbl_More"];
				if (lbl_More != null && (this.flowLayoutPanel1.Height + e.OldValue /*Use OldValue because of regression WJ-7901*/ > lbl_More.Top))
				{
					FillFlowLayoutPanel();
				}
			}
		}

		private void Dashboard_Main_Load(object sender, EventArgs e)
        {
            PrepareLists();

			var random = new Random();

			if (_Orders == null || _Orders.Count == 0)            {
                _Orders = new List<UserControlFlowLayout_Example.Order>();
                for (int i = 0; i < 10; i++)
                {
                    Order newOrder = new UserControlFlowLayout_Example.Order();
                    newOrder.OrderNumber = "No. 100" + random.Next(1000).ToString();
                    newOrder.Customer = _Customers[random.Next(_Customers.Count - 1)];
                    newOrder.Carrier = _Carriers[random.Next(_Carriers.Count - 1)];
                    newOrder.Address = _Addresses[random.Next(_Addresses.Count - 1)];
                    newOrder.Freight = _Freights[random.Next(_Freights.Count - 1)];
                    newOrder.CustomerPrice = _CustomerPrices[random.Next(_CustomerPrices.Count - 1)];
                    newOrder.CarrierPrice = _CarrierPrices[random.Next(_CarrierPrices.Count - 1)];

                    _Orders.Add(newOrder);
                }
            }

            FillFlowLayoutPanel();

        }
        private void PrepareLists()
        {
            if (_Customers == null)
                _Customers = new List<string> { "Volkswagen", "Audi", "BMW", "Mercedes", "Porsche" };

            if (_Carriers == null)
                _Carriers = new List<string> { "Czako Trans", "SML Cargo", "Fast-Trans", "Cargo_Sped", "Super Tarns Group" };

            if (_Addresses == null)
                _Addresses = new List<string> { "47179 Duisburg", "42929 Wermelskirchen", "54296 Trier", "80331 München", "38440 Wolfsburg" };

            if (_Freights == null)
                _Freights = new List<string> { "3 Pal. a 450 kg", "2 Gibo 100x200x50 = 300 kg", "10 Boxes = 50kg", "1 Pal. 1T" };

            if (_CustomerPrices == null)
                _CustomerPrices = new List<string> { "250.00€", "365.78€", "120.50€", "1450.00€", "768.79€", "319.00€" };

            if (_CarrierPrices == null)
                _CarrierPrices = new List<string> { "75.00€", "475.00€", "1075.00€", "575.00€", "175.00€", "750.00€" };
        }

		private void FillFlowLayoutPanel()
		{
			foreach (Order order in _Orders)
			{
				try
				{
					CustomerControl custcon = new UserControlFlowLayout_Example.CustomerControl();
					custcon.OrderNumber = order.OrderNumber;
					custcon.Customer = order.Customer;
					custcon.Carrier = order.Carrier;
					custcon.Address = order.Address;
					custcon.Freight = order.Freight;
					custcon.CustomerPrice = order.CustomerPrice;
					custcon.CarrierPrice = order.CarrierPrice;

					flowLayoutPanel1.Controls.Add(custcon);
				}
				catch (Exception ex)
				{ }
			}

			Label lbl_More = (Label)flowLayoutPanel1.Controls["lbl_More"];
			if (lbl_More == null)
			{
				lbl_More = new Label();
				lbl_More.Name = "lbl_More";
				lbl_More.Width = 300;
				lbl_More.Height = 50;
				lbl_More.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
				lbl_More.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
				lbl_More.ImageSource = "ajax-loader";
				lbl_More.Text = "Loading more elements...";
			}

			flowLayoutPanel1.Controls.Add(lbl_More);
		}


        private void Btn_More_Click(object sender, EventArgs e)
        {
            FillFlowLayoutPanel();
        }        
    }
}
